	BmpBut      proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	BmpButnProc proto :DWORD,:DWORD,:DWORD,:DWORD
	
.code

BmpBut proc hParent:DWORD,topX:DWORD,topY:DWORD,rnum:DWORD,cx_:DWORD,ID:DWORD

    LOCAL hButn1  :DWORD
    LOCAL hImage  :DWORD
    LOCAL hModule :DWORD
    LOCAL wid     :DWORD
    LOCAL hgt     :DWORD
    LOCAL hBmpU   :DWORD
    LOCAL hBmpO   :DWORD
    LOCAL hBmpD   :DWORD
    LOCAL Rct     :RECT
    LOCAL wc      :WNDCLASSEX
    LOCAL im_list :DWORD

    invoke GetModuleHandle,NULL
    mov    hModule, eax
    
    invoke ImageList_LoadImage, hModule, rnum, cx_, 0, 0, IMAGE_BITMAP, LR_DEFAULTCOLOR+LR_CREATEDIBSECTION
    mov    im_list, eax
    invoke ImageList_GetIcon, im_list, 0, ILD_NORMAL
    mov    hBmpU, eax
    invoke ImageList_GetIcon, im_list, 1, ILD_NORMAL
    mov    hBmpO, eax
    invoke ImageList_GetIcon, im_list, 2, ILD_NORMAL
    mov    hBmpD, eax

	invoke ImageList_Destroy, im_list
	
    jmp @F
      Bmp_Button_Class db "Bmp_Button_Class",0
    @@:

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,    offset BmpButnProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     16
      push hModule
      pop wc.hInstance
    mov wc.hbrBackground,  COLOR_BTNFACE+1
    mov wc.lpszMenuName,   NULL
    mov wc.lpszClassName,  offset Bmp_Button_Class
    mov wc.hIcon,          NULL
      invoke LoadCursor,NULL,IDC_ARROW
    mov wc.hCursor,        eax
    mov wc.hIconSm,        NULL

    invoke RegisterClassEx, ADDR wc

    invoke CreateWindowEx,WS_EX_TRANSPARENT,
            ADDR Bmp_Button_Class,NULL,
            WS_CHILD or WS_VISIBLE,
            topX,topY,100,100,hParent,ID,
            hModule,NULL

    mov hButn1, eax

    invoke SetWindowLong,hButn1,0,hBmpU
    invoke SetWindowLong,hButn1,4,hBmpO
    invoke SetWindowLong,hButn1,8,hBmpD

    jmp @F
    ButnImageClass db "STATIC",0
    @@:

    invoke CreateWindowEx,0,
            ADDR ButnImageClass,NULL,
            WS_CHILD or WS_VISIBLE or SS_ICON,
            0,0,0,0,hButn1,ID,
            hModule,NULL

    mov hImage, eax

    invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_ICON,hBmpU

    invoke GetWindowRect,hImage,ADDR Rct
    invoke SetWindowLong,hButn1,12,hImage

    mov eax, Rct.bottom
    mov edx, Rct.top
    sub eax, edx
    mov hgt, eax

    mov eax, Rct.right
    mov edx, Rct.left
    sub eax, edx
    mov wid, eax

    invoke SetWindowPos,hButn1,HWND_TOP,0,0,wid,hgt,SWP_NOMOVE

    invoke ShowWindow,hButn1,SW_SHOW

    mov eax, hButn1

    ret

BmpBut endp

BmpButnProc proc hWin   :DWORD,
                 uMsg   :DWORD,
                 wParam :DWORD,
                 lParam :DWORD

    LOCAL hBmpU  :DWORD
    LOCAL hBmpO  :DWORD
    LOCAL hBmpD  :DWORD
    LOCAL hImage :DWORD
    LOCAL hParent:DWORD
    LOCAL ID     :DWORD
    LOCAL ptX    :DWORD
    LOCAL ptY    :DWORD
    LOCAL bWid   :DWORD
    LOCAL bHgt   :DWORD
    LOCAL Rct    :RECT
    LOCAL tme:TRACKMOUSEEVENT

    .data
		cFlag  dd 0      ; a GLOBAL variable for the "clicked" setting
		cEnter dd 0
    .code

    .if uMsg == WM_LBUTTONDOWN
        invoke GetWindowLong,hWin,8
        mov hBmpD, eax
        invoke GetWindowLong,hWin,12
        mov hImage, eax
        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_ICON,hBmpD
        invoke SetCapture,hWin
        mov cFlag, 1
	.elseif uMsg == WM_MOUSEMOVE
		.if cEnter == 0
			mov cEnter,1
		.else
			ret
		.endif
		
		invoke GetWindowLong,hWin,4
		mov hBmpO, eax
		invoke GetWindowLong,hWin,12
		mov hImage, eax
		invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_ICON,hBmpO
		mov    tme.cbSize,sizeof TRACKMOUSEEVENT
		mov    tme.dwFlags,TME_LEAVE
		mov    eax,hWin
		mov    tme.hwndTrack,eax
		mov    tme.dwHoverTime,2
		invoke TrackMouseEvent,ADDR tme
		
	.elseif uMsg == WM_MOUSELEAVE
		mov cEnter,0
		invoke GetWindowLong,hWin,0
		mov hBmpO, eax
		invoke GetWindowLong,hWin,12
		mov hImage, eax
		invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_ICON,hBmpO
			
    .elseif uMsg == WM_LBUTTONUP
		.if cFlag == 0
			ret
		.else
			mov cFlag, 0
		.endif
		invoke GetWindowLong,hWin,0
		mov hBmpU, eax
		invoke GetWindowLong,hWin,12
		mov hImage, eax
		invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_ICON,hBmpU
		
		mov eax, lParam
		cwde
		mov ptX, eax
		mov eax, lParam
		rol eax, 16
		cwde
		mov ptY, eax
		
		invoke GetWindowRect,hWin,ADDR Rct
		
		mov eax, Rct.right
		mov edx, Rct.left
		sub eax, edx
		mov bWid, eax
		
		mov eax, Rct.bottom
		mov edx, Rct.top
		sub eax, edx
		mov bHgt, eax
		; --------------------------------
		; exclude button releases outside
		; of the button rectangle from
		; sending message back to parent
		; --------------------------------
		cmp ptX, 0
		jle @F
		cmp ptY, 0
		jle @F
		mov eax, bWid
		cmp ptX, eax
		jge @F
		mov eax, bHgt
		cmp ptY, eax
		jge @F
		
		invoke GetParent,hWin
		mov hParent, eax
		invoke GetDlgCtrlID,hWin
		mov ID, eax
		invoke SendMessage,hParent,WM_COMMAND,ID,hWin
		
		@@:
		
		invoke ReleaseCapture
	
	.elseif uMsg==WM_DESTROY
		invoke GetWindowLong,hWin,0
		invoke DestroyIcon, eax
		invoke GetWindowLong,hWin,4
		invoke DestroyIcon, eax
		invoke GetWindowLong,hWin,8
		invoke DestroyIcon, eax

	.endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

BmpButnProc endp
